/*  Copyright (C) 2008 Chris Hellyar <chris@trash.co.nz>
 *
 *  This software is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *                   
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *                                  
 *  You should have received a copy of the GNU General Public License
 *  along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA 02111-1307  USA.  (See COPYING file) */


// Config stuff below here for libconfuse
cfg_t *cfg;  // global structure to hold the config results, sorta.
int Verbose; // flag for Verbose or not ie: debug mode.
int Daemon;  // flag for changing to a daemon or not.

int ReadConfig(void) {
	cfg_opt_t input_opts[] = { // Options for input blocks in config file.
		CFG_STR("Name","default",CFGF_NONE),
		CFG_INT("DeviceID",0,CFGF_NONE),
		CFG_INT("Address",0,CFGF_NONE),
		CFG_FLOAT("Scale",1,CFGF_NONE),
		CFG_FLOAT("Offset",0,CFGF_NONE),
		CFG_END()
	};

	cfg_opt_t Options[] = {
		CFG_BOOL("Verbose",FALSE,CFGF_NONE),
		CFG_BOOL("Daemon",FALSE,CFGF_NONE),
	        CFG_STR("Port","/dev/null",CFGF_NONE),
		CFG_STR("LogFile","/dev/null",CFGF_NONE),
		CFG_STR("DBServer","",CFGF_NONE),
		CFG_STR("DBName","myio",CFGF_NONE),
		CFG_STR("DBPassword","password",CFGF_NONE),
		CFG_STR("DBUser","myio",CFGF_NONE),
		CFG_INT("Interval",0,CFGF_NONE),
		CFG_BOOL("UnixTime",TRUE,CFGF_NONE),
		CFG_SEC("input", input_opts, CFGF_MULTI ),
		CFG_END()
	};

	int ret; // return value
	cfg = cfg_init(Options, 0);

	// do the config in the working directory first...
	ret = cfg_parse(cfg, "logger.conf");
	if(ret) ret = cfg_parse(cfg, "~/logger.conf");  // try home directory
	if(ret) ret = cfg_parse(cfg, "/etc/logger.conf");  // last try /etc

	Verbose=cfg_getbool(cfg, "Verbose");
	Daemon=cfg_getbool(cfg, "Daemon");

	return ret;
}
